#ifndef ORACLE_H_
#define ORACLE_H_     


////////////////////////////////////////////////////////////////////////////////
//                                  Include                                   //
////////////////////////////////////////////////////////////////////////////////


#include "OPTtypes.h"
using namespace OPTtypes_di_unipi_it;

#include <ilcplex/ilocplex.h>
ILOSTLBEGIN


////////////////////////////////////////////////////////////////////////////////
//                             Type definitions                               //
////////////////////////////////////////////////////////////////////////////////


typedef IloArray<IloIntVarArray> IntVarMatrix;
typedef IloArray<IloIntArray> IntMatrix;


////////////////////////////////////////////////////////////////////////////////
//                                   Class                                    //
////////////////////////////////////////////////////////////////////////////////


class Oracle
{
private: //----- Private -------------------------------------------------------

  IloEnv env;
  IntVarMatrix x;
  IloNumArray u;
  IntMatrix a;
  IloIntArray r;
  IloExpr cx;
  IloObjective obj;
  IloModel model;
  IloCplex cplex;
  IloInt m;               
  IloInt n;               
  IloInt uSize;           // u size
  IloInt xDims;           // x dimensions
  IloInt xDim1Size;       // x dimension 1 size
  IloInt xDim2Size;       // x dimension 2 size
  bool isMinProblem;      // Is primal problem of min type
  unsigned int* ucVector; // Vector with unconstrained u variables
  int iteration;

public: //----- Public ---------------------------------------------------------
 
  Oracle(char* filename); // Constructor
  ~Oracle();              // Destructor
  void Solve(const double uVector[], double &fValue, double sgVector[], 
	     double xVector[]);
  long getUSize();
  long getXDims();
  long getXDim1Size();
  long getXDim2Size();
  bool getIsMinProblem();
  unsigned int* getUCVector();

};


////////////////////////////////////////////////////////////////////////////////


#endif
